<?php
/* GENERA .java */
	echo "<li type=\"square\"><b>Varios</b>\n";

	$tpl->define(
		array(
			"classmap" => "schema_1.xml",
			"classmap_item" => "schema_2.xml"
		)
	);
	/* Crea classmap.xml */
		$siparse = false;
		for ($i=0; $i<count($fields); $i++) {			
			if (strlen($fields[$i])) {
				$fielduc = ucfirst(strtolower($fields[$i] ));
				$fieldl = strtolower($fields[$i] );
				$fieldu = strtoupper($fields[$i] );
				if ($primaria[$i]) {
					$tpl->assign("SCHEMA_PRIMARY", "key=\"primary\"");
					$tpl->assign("FIELDL2", "id");
				} else {
					$tpl->assign("SCHEMA_PRIMARY", "");
					$tpl->assign("FIELDL2", $fieldl);
				}
				$tpl->assign("FIELDUC", $fielduc);
				$tpl->assign("FIELDL", $fieldl);
				$tpl->assign("FIELDU", $fieldu);
				$tpl->parse("SCHEMA_ITEMS", ".classmap_item");
				$siparse = true;
			}
		}
	/* final */
	if (!$siparse) $tpl->assign("SCHEMA_ITEMS", "");
	$tpl->assign("CLASSUC", ucfirst(strtolower($classname)) );
	$tpl->assign("CLASSL", strtolower($classname) );
	$tpl->assign("CLASSU", strtoupper($classname) );
	$tpl->assign("DATE", date("d/m/Y H:i:s") );
	$tpl->parse("FINAL", "classmap");
	$nombre_fichero = ucfirst(strtolower($classname)) . ".classmap";	
	$fp = fopen("salida/$nombre_fichero", "w");
	fwrite($fp, $tpl->fetch("FINAL"));
	fclose($fp);
	echo "<li> <a href=\"salida/$nombre_fichero\" target=\"_blank\">$nombre_fichero</a> ";

	$tpl->define(
		array(
			"sql1" => "sql1.tpl",
			"sql2" => "sql2.tpl",
			"sql3" => "sql3.tpl"
		)
	);
	/* Crea SQL */
		$strconst = "";
		$consparse = false;
		$cont = 0;
		for ($i=0; $i<count($fields); $i++) {			
			if (strlen($fields[$i])) {
				$tpl->assign("COMMA", ",\n\t");
				$fielduc = ucfirst(strtolower($fields[$i] ));
				$fieldl = strtolower($fields[$i] );
				$fieldu = strtoupper($fields[$i] );
				if ($primaria[$i]) {
					if ($cont) $strconst.=", ";
					$strconst.="$fieldu";
					$consparse = true;
				}
				$tpl->assign("FIELDUC", $fielduc);
				$tpl->assign("FIELDL", $fieldl);
				$tpl->assign("FIELDU", $fieldu);
				$tpl->assign("FIELD_TIPO", strtoupper($tipovar[$i]));

				switch ($tipovar[$i]) {
					case "boolean":
						$tpl->assign("FIELD_TIPO", "NUMBER(1) CONSTRAINT \"$fieldu". date("i") ."_BOOL\" CHECK (\"$fieldu\" IN(0,1))");
						$tpl->assign("FIELD_TAMANY", "");
					break;
					case "minumber":
						$tmp = (strlen($tamany[$i])>1)?$tamany[$i]:"15,3";						
						$tpl->assign("FIELD_TIPO", "NUMBER($tmp) CONSTRAINT \"$fieldu". date("i") ."_INT\" CHECK (\"$fieldu\" >= 0)");
						$tpl->assign("FIELD_TAMANY", "");					
					break;
					case "date":
					case "char":
					case "long":
						$tpl->assign("FIELD_TAMANY", "");
					break;
					default;
						if ($tamany[$i]) $tpl->assign("FIELD_TAMANY", "($tamany[$i])");
						else $tpl->assign("FIELD_TAMANY", "(30)");
					break;
				}

				if ($notnull[$i]) $tpl->assign("NOT_NULL", "NOT NULL");
				else $tpl->assign("NOT_NULL", "");

				$tpl->parse("CAMPOS_SQL2", ".sql2");
				$cont++;
			}
		}
	/* final */
	if (!$consparse) {
		$tpl->assign("CAMPOS_SQL3", "");
	}
	else {
		$tpl->assign("TIPO_CONST", "PRIMARY KEY");
		$tpl->assign("LIST_CONST", "$strconst");
		$tpl->parse("CAMPOS_SQL3", "sql3");
	}
	$tpl->assign("PREFIX", ucfirst(strtolower($zona)) );
	$tpl->assign("CLASSUC", ucfirst(strtolower($classname)) );
	$tpl->assign("CLASSL", strtolower($classname) );
	$tpl->assign("CLASSU", strtoupper($classname) );
	$tpl->assign("DATE", date("d/m/Y H:i:s") );
	$tpl->parse("FINAL", "sql1");
	$nombre_fichero = ucfirst(strtolower($classname)) . ".sql_ext";	
	$fp = fopen("salida/$nombre_fichero", "w");
	fwrite($fp, $tpl->fetch("FINAL"));
	fclose($fp);
	echo "<li> <a href=\"salida/$nombre_fichero\" target=\"_blank\">$nombre_fichero</a> ";

	echo "<li type=\"square\"><b>JavaScript</b>\n";
	$tpl->define(
		array(
			"documento1" => "documento_base.rtf",
			"internalcheckjs" => "internal_check.js",
			"formcheckjs" => "PREFIX_CheckCLASS.js"
		)
	);
/* JS */
		$strparsejs = false;
		for ($i=0; $i<count($fields); $i++) {			
			if (strlen($fields[$i])) {
				$fieldl = strtolower($fields[$i] );
				$tpl->assign("FIELDL", $fieldl);
				$tpl->assign("FORMTYPE", $tipocheck[$i]);
				if ($checkform[$i]) {
					$tpl->parse("FORMSCRIPT", ".internalcheckjs");
					$strparsejs = true;
				}
			}
		}
	if (!$strparsejs) $tpl->assign("FORMSCRIPT", "");
	$tpl->parse("FINAL", "formcheckjs");
	$nombre_fichero = "$zona" . "Check". ucfirst(strtolower("$classname")) . ".js_ext";	
	$fp = fopen("salida/$nombre_fichero", "w");
	fwrite($fp, $tpl->fetch("FINAL"));
	fclose($fp);
	echo "<li> <a href=\"salida/$nombre_fichero\" target=\"_blank\">$nombre_fichero</a> ";

/* RTF */
	echo "<li type=\"square\"><b>Documentaci&oacute;n</b>\n";
	$tpl->parse("FINAL", "documento1");
	$nombre_fichero = "doc_" . strtolower($classname) . ".rtf";	
	$fp = fopen("salida/$nombre_fichero", "w");
	fwrite($fp, $tpl->fetch("FINAL"));
	fclose($fp);
	echo "<li> <a href=\"salida/$nombre_fichero\" target=\"_blank\">$nombre_fichero</a> ";


?>